#include <bits/stdc++.h>

// WA - don't consider the hits

using namespace std;

constexpr int MAXN = 5;
int n, k;
string grid[MAXN];
bool used[MAXN][MAXN];
int sizes[MAXN];
int ans = 0;

bool free_horiz(int x, int y, int len) {
    for (int i = 0; i < len; ++i) {
        if (y + i >= n or grid[x][y + i] == 'X' or used[x][y + i]) {
            return false;
        }
    }

    return true;
}

bool free_vert(int x, int y, int len) {
    for (int i = 0; i < len; ++i) {
        if (x + i >= n or grid[x + i][y] == 'X' or used[x + i][y]) {
            return false;
        }
    }

    return true;
}

inline void set_horiz(int x, int y, int len, bool val) {
    for (int i = 0; i < len; ++i) {
        used[x][y + i] = val;
    }
}

inline void set_vert(int x, int y, int len, bool val) {
    for (int i = 0; i < len; ++i) {
        used[x + i][y] = val;
    }
}

void dfs(int cell, int ship) {
    if (ship == k) {
        ++ans;
        return;
    }
    int x = cell / n;
    int y = cell % n;
    if (x >= n) return;

    // place horizontally
    if (free_horiz(x, y, sizes[ship])) {
        set_horiz(x, y, sizes[ship], true);
        dfs(0, ship + 1);
        set_horiz(x, y, sizes[ship], false);
    }
    
    // place vertically
    if (sizes[ship] > 1 and free_vert(x, y, sizes[ship])) {
        set_vert(x, y, sizes[ship], true);
        dfs(0, ship + 1);
        set_vert(x, y, sizes[ship], false);
    }

    // dont place
    dfs(cell + 1, ship);
}

int main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> grid[i];
    }

    for (int i = 0; i < k; ++i) {
        cin >> sizes[i];
    }

    dfs(0, 0);
    cout << ans << '\n';

    return 0;
}
