import java.util.*;

public class battleship_AN {
    static int count = 0;
    static int n, k, limit, hits, misses, mask;
    static int[] sizes = new int[5];

    static void solve(int board, int idx) {
        if (idx == k) {
            if ((board & misses) == 0 && ((mask - board) & hits) == 0) count++;
            return;
        }

        if (sizes[idx] == 1) {
            for (int i = 0; i < n * n; i++) {
                int ship = 1 << i;
                if ((ship & board) == 0) solve(ship + board, idx + 1);
            }
        } else {
            int hship = (1 << sizes[idx]) - 1;
            for (int i = 0; i < n; i++) {
                int ship = hship << (n * i);
                for (int j = 0; j < n - sizes[idx] + 1; j++) {
                    if ((ship & board) == 0) solve(ship + board, idx + 1);
                    ship <<= 1;
                }
            }
            int vship = 0;
            for (int i = 0; i < sizes[idx]; i++) {
                vship <<= n;
                vship += 1;
            }
            for (int i = 0; i < n - sizes[idx] + 1; i++) {
                int ship = vship << (n * i);
                for (int j = 0; j < n; j++) {
                    if ((ship & board) == 0) solve(ship + board, idx + 1);
                    ship <<= 1;
                }
            }
        }
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        n = s.nextInt();
        k = s.nextInt();
        hits = 0;
        misses = 0;
        for (int i = 0; i < n; i++) {
            String line = s.next();
            for (int j = 0; j < n; j++) {
                hits <<= 1;
                misses <<= 1;
                switch (line.charAt(j)) {
                    case 'X': misses++; break;
                    case 'O': hits++; break;
                }
            }
        }
        for (int i = 0; i < k; i++) sizes[i] = s.nextInt();
        limit = 1 << (n * n);
        mask = limit - 1;
        solve(0, 0);
        System.out.println(count);
    }
}
