#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9;
#define MAXN 100005

char g[5][6];
int dirs[2][2] = { 1, 0, 0, 1 };
int sizes[5];
int p[5][5];
int ans, n, k;
void check() {
  REP(i,0,n) REP(j,0,n) if (g[i][j] == 'O' && p[i][j] == 0) return;
  ans++;
}
bool outside(int i, int j) {
  return i >= n || j >= n || i < 0 || j < 0;
}
void place(int ki) {
  if (ki == k) {
    check();
    return;
  }
  REP(i,0,n) {
    REP(j,0,n) {
      int nd = sizes[ki] > 1 ? 2 : 1;
      REP(d,0,nd) {
        bool canPlace = true;
        REP(s,0,sizes[ki]) {
          int ni = i + dirs[d][0] * s, nj = j + dirs[d][1] * s;
          if (outside(ni, nj) || g[ni][nj] == 'X' || p[ni][nj] == 1) {
            canPlace = false;
            break;
          }
        }
        if (canPlace) {
          REP(s,0,sizes[ki]) {
            int ni = i + dirs[d][0] * s, nj = j + dirs[d][1] * s;
            p[ni][nj] = 1;
          }
          place(ki + 1);
          REP(s,0,sizes[ki]) {
            int ni = i + dirs[d][0] * s, nj = j + dirs[d][1] * s;
            p[ni][nj] = 0;
          }
        }
      }
    }
  }
}
int main() {
  cin >> n >> k;
  REP(i,0,n) cin >> g[i];
  REP(i,0,k) cin >> sizes[i];
  place(0);
  cout << ans << endl;
  return 0;
}
