#!/usr/bin/env python3

import sys
n, k = [int(x) for x in sys.stdin.readline().split()]
g = [sys.stdin.readline().strip() for _ in range(n)]
p = [[0] * n for _ in range(n)]
size = [int(sys.stdin.readline()) for _ in range(k)]

ans = 0
covered_O = 0
for i in range(n):
  for j in range(n):
    if g[i][j] == 'O': covered_O += 1

dirs = [[1, 0], [0, 1]]
def place(ki):
  global ans, covered_O
  if ki == k:
    if covered_O == 0: ans += 1
    return
  for i in range(n):
    for j in range(n):
      sz = size[ki]
      for dir in dirs[:(2 if sz > 1 else 1)]:
        if i + sz * dir[0] > n or j + sz * dir[1] > n: continue
        can_place = True
        for s in range(size[ki]):
          ni, nj = i + dir[0] * s, j + dir[1] * s
          if g[ni][nj] == 'X' or p[ni][nj] > 0:
            can_place = False
            break
        if can_place:
          for s in range(size[ki]):
            ni, nj = i + dir[0] * s, j + dir[1] * s
            p[ni][nj] = 1
            if g[ni][nj] == 'O': covered_O -= 1
          place(ki + 1)
          for s in range(size[ki]):
            ni, nj = i + dir[0] * s, j + dir[1] * s
            p[ni][nj] = 0
            if g[ni][nj] == 'O': covered_O += 1

place(0)
print (ans)
