#!/usr/bin/env python3

# This is the exact same implementation as battleship_bowen.cpp.
# But unfortunately python is too slow to pass, while the cpp solution took less than 1 second.

import sys
n, k = [int(x) for x in sys.stdin.readline().split()]
g = [sys.stdin.readline().strip() for _ in range(n)]
p = [[0] * n for _ in range(n)]
size = [int(sys.stdin.readline()) for _ in range(k)]

ans = 0
def check():
  global ans
  for i in range(n):
    for j in range(n):
      if g[i][j] == 'O' and p[i][j] == 0: return
  ans += 1

def outside(i, j):
  return i >= n or j >= n or i < 0 or j < 0

dirs = [[1, 0], [0, 1]]
def place(ki):
  if ki == k:
    check()
    return
  for i in range(n):
    for j in range(n):
      nd = 2 if size[ki] > 1 else 1
      for dir in dirs[:nd]:
        can_place = True
        for s in range(size[ki]):
          ni, nj = i + dir[0] * s, j + dir[1] * s
          if outside(ni, nj) or g[ni][nj] == 'X' or p[ni][nj] == 1:
            can_place = False
            break
        if can_place:
          for s in range(size[ki]):
            ni, nj = i + dir[0] * s, j + dir[1] * s
            p[ni][nj] = 1
          place(ki + 1)
          for s in range(size[ki]):
            ni, nj = i + dir[0] * s, j + dir[1] * s
            p[ni][nj] = 0

place(0)
print (ans)
